using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApplication
{
    class Program
    {
        static void Main(string[] args)
        {
                        string[] s = Console.ReadLine().Split();
            int n = int.Parse(s[0]);
            int q = int.Parse(s[1]);
            long[] d = new long[n];
            long[] p = new long[n];
            long[] k = new long[q];
            for (int i = 0; i < n; i++)
            {
                string[] u = Console.ReadLine().Split();
                d[i] = long.Parse(u[0]);
                p[i] = long.Parse(u[1]);
            }
            for (int j = 0; j < q; j++)
            {
                k[j] = long.Parse(Console.ReadLine());
            }
            for (int j = 0; j < q; j++)
            {
                long zb = 0;
                long poj = 0;
                int o = 0;
                for (int i = 0; i < n; i++)
                {
                    if (d[i] <= k[j])
                    {
                        if (i != 0)
                        {
                            if (d[i] != d[i - 1] + 1)
                            {
                                long z = d[i] - d[i - 1] - 1;
                                if (z <= zb)
                                {
                                    zb = zb - z;
                                    poj = poj + z;
                                }
                                else
                                {
                                    poj = poj + zb;
                                    zb = 0;
                                }
                            }
                        }
                        zb += p[i];
                        zb--;
                        poj++;
                        o = i;
                    }
                    else if (i != 0)
                    {
                        o = i - 1;
                        break;
                    }
                    else
                    {
                        Console.WriteLine(poj);
                        poj = -1;
                    }
                }
                if (poj != -1)
                {
                    if (zb >= k[j] - d[o])
                    {
                        poj += k[j] - d[o];
                    }
                    else
                        poj += zb;
                    Console.WriteLine(poj);
                }
            }
        }
    }
}